Page MenuHome

Advanced UI Menus/Brush Modes: promote 2.79 addons release.
Closed, ResolvedPublic

Description

Menus to aid the user and increase the speed of interacting with blender's UI.

Addon:


Wiki: http://wiki.blender.org/index.php/Extensions:2.6/Py/Scripts/3D_interaction/Advanced_UI_Menus

Edit from meta-androcto:
Parts of this addon work very well & are appropriate for Blender 2.79 (the brush type menus)
I've made changes & a customized use case specific file is located in the brush menu file below.


Given the significant impact on this addon (most parts have been used or removed) the original addon will need to be rewritten, thus I'll use this task as reference point.
Thanks to @Ryan Inch (Imaginer)
After talks with Ryan in irc we are happy with this addon & the hotkey in Brush modes Alt/v
This is not designed to set up your entire sculpt workflow. It is designed to provide quick access to sculpt settings whilst sculpting in full screen mode or other so settings can be easily changed on the fly whilst working, without jumping back to the toolshelf set up for small changes.

Details

Type
Patch

Event Timeline

Ryan Inch (Imaginer) updated the task description. (Show Details)
Ryan Inch (Imaginer) raised the priority of this task from to Needs Triage by Developer.
Ryan Inch (Imaginer) added a project: Addons.
Ryan Inch (Imaginer) set Type to Patch.

It's not clear to me what these menu(s?) actually do, seems like it's a mix of all sorts of things the author uses on a regular basis? Then it is probably not a good idea to make it official. Maybe the patch should be broken into smaller parts.

@Thomas Dinges (dingto): Do you mind if i assign this to you for review?

Lukas Toenne (lukastoenne) triaged this task as Normal priority.Nov 12 2014, 10:46 AM

I don't have time to review an add-on, sorry.

On a quick look, this indeed seems like a collection of various menus, we cannot accept it in this state.

Lukas Toenne (lukastoenne) claimed this task.

Closing the patch then. You're free to distribute this as you like of course, but we can't accept it as an official addon, sorry.

Hi, I submitted this here on the advice of someone from the blenderui IRC channel. If this was submitted for the official addons I apologize, I only wanted it to go into contrib so I could get more feedback and perhaps discuss it with other Blender devs to get it ready for release.

About the addon, it isn't just a mix of menus I use on a random basis, it was designed to mimic the functionality of Pie Menus (with a few improvements of my own), but use the traditional menu layout. It also has a prototype for a user customize-able menu that is customized by adding operators, etc. from a ui provided by the menu.

I know that there are plenty of things that need to be fixed/improved and that possibly some things should be separated out e.g. the custom menu, but I hope that eventually this will be a good addon that can be included as an official addon, and that this comment makes it clearer what the addon does and why I submitted it.

I don't see any reason why this cannot be developed in contrib.
It has the possibility of incorporating some smaller addons & bringing a single ui menu addon, rather than the several we have now. I would expect.

Addons development should be:
Submit useful addon to contrib.
Learn Blender addon management tools & refine addon based on developer & user feedback.
Then Submit for Review for release.

I'm re-opening to allow further consideration.

Takanu added a subscriber: Takanu.EditedNov 24 2014, 6:14 PM

I've used this plugin for a while before Pie Menus came out, and I think this could potentially aid the current keymap project, but I don't feel some of these menus make the workflow faster and should be broken down into smaller, more easily accessible menus. For example, the paint control menu seems like it would take longer to use to access brushes than currently pressing one of the key commands or bringing up the toolbar. Something like that should have a dedicated pie menu or series of pie menus, where brushes are grouped by a general category.

This is a cool idea, but I think for it to be successful, some of the menus in the plugin need to be broken down into smaller menus that are accessible through more key shortcuts, and that pie menus should be used where appropriate to enable more instantaneous accessibility of important tools.

Takanu added a comment.EditedDec 4 2014, 3:35 PM

Sorry if a double post isn't appropriate, I am new to using the developer site :)

I feel that the example I raised above regarding paint control being harder to access is why you should actually include Pie Menus in your plugin. Lists are cool for certain things, but for brushes a very instant and gestural workflow is important in accessing them, as they are tools people switch between all the time in a sculpting workflow, and Pie Menus let you very quickly access them. Lists however suit more technical, one-off operators that are used infrequently, and I think you should redesign some elements of the plugin accordingly. If you like, i'd be happy to try to use it in more detail and give you better feedback on it.

Hi Takanu,
I meant to reply earlier, but have been fairly busy and kept forgetting. I agree that in certain situations Pies are much better than lists(e.g. the view menu) and that my menus can be improved a lot still. You're right about the paint control menu, it needs some work and, based on current blender ui practices, splitting it up might be the best way to go. I would also be very grateful if you would continue testing and providing me feedback. :)

@ the blender devs: Is this a good place for feedback/discussion on/of my addon, and if not, where would a good place be?

Campbell Barton (campbellbarton) lowered the priority of this task from Normal to Needs Information from User.May 20 2015, 10:21 AM

These kinds of usability scripts can be OK... if developers like to maintain them in contrib. and they seem generally useful.

However there is some fairly odd code just from a quick check...

  • __location__ = os.path.realpath(os.path.join(os.getcwd(), os.path.dirname(__file__))) - the os.getcwd() can be anything, and shouldnt be used.
  • sys.path.append(os.path.join(os.path.dirname(__file__), '..', 'advanced_ui_menus')), you don't have to modify the sys.path, use relative imports instead.

Marking as incomplete, this can go into contrib if the issues above are addressed.

I have hopefully addressed the issues Campbell identified and updated the task with the new version.

Bastien Montagne (mont29) raised the priority of this task from Needs Information from User to Normal.Jun 13 2015, 10:25 AM
Brendon Murphy (meta-androcto) raised the priority of this task from Normal to Confirmed, Medium.

hi, I've ported the Brush sections of this addon to create a new sculpt/paint brush mode menu.
raising priority to confirmed.
The new version has all the brush menus to one main menu & one hotkey. Alt/V for testing purpose but this seems ok.
It has been designed to replace the Viewport pie menu Sculpt brushes, as they don't really sit well & will be removed.
Current my dev version: (sorry pic includes custom brushes as I was testing)

Brendon Murphy (meta-androcto) renamed this task from Advanced UI Menus to Advanced UI Menus/Brush Modes.Feb 19 2017, 11:37 AM
Brendon Murphy (meta-androcto) updated the task description. (Show Details)

Initial commit made to addons contrib, updated wiki page to follow after code clean & menu finalize

Brendon Murphy (meta-androcto) renamed this task from Advanced UI Menus/Brush Modes to Advanced UI Menus/Brush Modes:promote 2.79 addons release..Mar 12 2017, 12:51 PM
Brendon Murphy (meta-androcto) updated the task description. (Show Details)
Brendon Murphy (meta-androcto) renamed this task from Advanced UI Menus/Brush Modes:promote 2.79 addons release. to Advanced UI Menus/Brush Modes: promote 2.79 addons release..

Here is an update that brings this up to the stable development level of my Advanced UI Menus:

@Ryan Inch (Imaginer)
Closing this task, I've committed brush menus to release. As we discussed, I'll close this task now & feel free to create a new task when we are closer to 2.8 with your full toolset.
Thanks for your help & support here.

Please update advanced ui menus for 2.8. Thanks.

Don't worry. I'll make sure both Advanced UI Menus & space_view_3d_brush_modes get updated for the 2.8 release.

thank you very much, I can not live without that addon